// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

// transforms
float4x4 tW: WORLD;       
float4x4 tV: VIEW;        
float4x4 tP: PROJECTION;
float4x4 tWVP: WORLDVIEWPROJECTION;

// 4 hard coded input vectors for the blobs ()x / y/ strength) 
float3 b0 <string uiname="blob 0";> ={0,0,0};
float3 b1 <string uiname="blob 1";> ={0,0,0};
float3 b2 <string uiname="blob 2";> ={0,0,0};
float3 b3 <string uiname="blob 3";> ={0,0,0};


float tresh <string uiname="treshold";> =4.;
float offset   <string uiname="offset";> =5.;

struct vs2ps
{
    float4 Pos  : POSITION;
    float2 TexCd : TEXCOORD0;
};

// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------
vs2ps VS( float4 PosO  : POSITION, float4 TexCd : TEXCOORD0)
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;

    //transform position
    Out.Pos = mul(PosO, tWVP);
    
    //texturecoordinates
    Out.TexCd = TexCd;

    return Out;
}

// --------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------------------
float4 PS(vs2ps In): COLOR
{
    float d = 0.;
    float sum = 0.;

    d=distance(In.TexCd, float2(b0.x, b0.y));
    sum+=b0.z/(d*d) ;

    d=distance(In.TexCd, float2(b1[0], b1[1]));
    sum+=b1[2]/(d*d);

    d=distance(In.TexCd, float2(b2[0], b2[1])) ;
    sum+=b2[2]/(d*d) ;

    d=distance(In.TexCd, float2(b3[0], b3[1]));
    sum+=b3[2]/(d*d);

    float col=(sum/tresh )-offset;

    return col;
}

// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------

technique metaBall2D
{
    pass P0
    {
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}
