// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

#define nBlobs 8

// transforms
float4x4 tW: WORLD;       
float4x4 tV: VIEW;        
float4x4 tP: PROJECTION;
float4x4 tWVP: WORLDVIEWPROJECTION;

float3 blobs[nBlobs] <string uiname="blobs";>;

float tresh <string uiname="treshold";> =4.;
float offset   <string uiname="offset";> =5.;

struct vs2ps
{
    float4 Pos  : POSITION;
    float2 TexCd : TEXCOORD0;
};

// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------
vs2ps VS( float4 PosO  : POSITION, float4 TexCd : TEXCOORD0)
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;

    //transform position
    Out.Pos = mul(PosO, tWVP);
    
    //texturecoordinates
    Out.TexCd = TexCd;

    return Out;
}

// --------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------------------
float4 PS(vs2ps In): COLOR
{
    float d = 0.;
    float sum = 0.;

    for(int i=0; i<nBlobs; i++)
    {
         d=distance(In.TexCd, float2(blobs[i].x, blobs[i].y));
         sum+=blobs[i].z/(d*d) ;
    }

    float col=(sum/tresh )-offset;

    return col;
}

// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------

technique metaBall2D
{
    pass P0
    {
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}
