// Gouraud-Lighting : calculate color (lighted) for the vertices and interpolate over the pixels

// -------------------------------------------------------------------------------------------------------------------------------------
// PARAMETERS:
// -------------------------------------------------------------------------------------------------------------------------------------

//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (DX9)
float4x4 tWV: WORLDVIEW;
float4x4 tWVP : WORLDVIEWPROJECTION;
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (DX9)

//material properties
float4 col  : COLOR <String uiname="Color";>  = {  0.3, 0.3, 0.3, 1.00000  };


float time <string uiname="Time";> = 0;
float2 mousepos;

float test = 0;
float fr=0.1;

// -------------------------------------------------------------------------------------------------------------------------------------
// VERTEXSHADER
// -------------------------------------------------------------------------------------------------------------------------------------

struct VS_OUTPUT
{
    float4 Pos: POSITION;
    float2 TexC : TEXCOORD0;
};

VS_OUTPUT VSWave(
    float4 Pos: POSITION,
    float3 Norm: NORMAL,
    float2 Tex : TEXCOORD0)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    float4 p = Pos;
    float4 tp = mul( Pos, tWVP );
    float r = sqrt(pow( distance(tp.x, 0), 2) + pow(distance(tp.y, 0), 2));
    p.z += sin(r*test+time) * fr;

    Out.Pos = mul( p, tWVP );
    Out.TexC = Tex;
    
    return Out;
}


// -------------------------------------------------------------------------------------------------------------------------------------
// PIXELSHADER
// -------------------------------------------------------------------------------------------------------------------------------------


float4 PSNoCol(float4 Amb: TEXCOORD0): COLOR
{
    return col;
}


// -------------------------------------------------------------------------------------------------------------------------------------
// TECHNIQUES:
// -------------------------------------------------------------------------------------------------------------------------------------

technique TWave
{
    pass P0
    {
        VertexShader = compile vs_1_1 VSWave();
        PixelShader = compile ps_2_0 PSNoCol();
    }
}
